#include "hardware.h"

void initPeripherals(void){
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_BMX1 |
													RCC_APB1Periph_GPIOA |
													RCC_APB1Periph_GPIOB |
													RCC_APB1Periph_GPIOC |
													RCC_APB1Periph_GPIOD, ENABLE);
	
  GPIO_Init(LED1_port, LED1_pin, GPIO_MODE_OUT | GPIO_OTYPE_PP | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	GPIO_Init(LED2_port, LED2_pin, GPIO_MODE_OUT | GPIO_OTYPE_PP | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	
	GPIO_Init(DISP_A_port, DISP_A_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_B_port, DISP_B_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_C_port, DISP_C_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_D_port, DISP_D_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_E_port, DISP_E_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_F_port, DISP_F_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_G_port, DISP_G_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_DP_port, DISP_DP_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	
	GPIO_Init(DISP_COM1_port, DISP_COM1_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_COM2_port, DISP_COM2_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_COM3_port, DISP_COM3_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_COM4_port, DISP_COM4_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);

	GPIO_Init(SW1_port, SW1_pin, GPIO_MODE_IN | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	GPIO_Init(SW2_port, SW2_pin, GPIO_MODE_IN | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);

	GPIO_Init(POT_port, POT_pin, GPIO_MODE_ANA);

	/* I/O podlaczone do potencjometru jako wejscie analogowe */
	GPIO_Init(POT_port, POT_pin, GPIO_MODE_ANA);

	/* konfiguracja linii SDA i SCL jako AF nr 4, linie typu otwarty dren */
	GPIO_Init(GPIOB, GPIO_Pin_10, GPIO_MODE_AF |GPIO_OTYPE_OD | GPIO_PUPD_NOPULL |GPIO_SPEED_HIGH |GPIO_AF4);
	GPIO_Init(GPIOB, GPIO_Pin_11, GPIO_MODE_AF |GPIO_OTYPE_OD | GPIO_PUPD_NOPULL |GPIO_SPEED_HIGH |GPIO_AF4);
	

	/* domyslna konfiguracja SysTicka z czestotliwoscia 1 kHz @ SYSCLK = 72 MHz */
	SysTick_Config(72000000 / 1000);
	
	/* konfiguracja linii UART1 */
	GPIO_Init(UART_TX_port, UART_TX_pin, GPIO_MODE_AF | GPIO_OTYPE_PP | GPIO_PUPD_UP | GPIO_SPEED_HIGH | GPIO_AF7);
	GPIO_Init(UART_RX_port, UART_RX_pin, GPIO_MODE_AF | GPIO_OTYPE_PP | GPIO_PUPD_UP | GPIO_SPEED_HIGH | GPIO_AF7);

	LED_onoff(1, LED_OFF);
	LED_onoff(2, LED_OFF);

}

void LED_onoff(uint8_t led, LED_state_t state){
	
	if(led == 1){
		
			if(state == LED_ON)
					GPIO_ResetBits(LED1_port, LED1_pin);
			else
					GPIO_SetBits(LED1_port, LED1_pin);
		
	}else if(led == 2){

			if(state == LED_ON)
					GPIO_ResetBits(LED2_port, LED2_pin);
			else
					GPIO_SetBits(LED2_port, LED2_pin);
		
	}
}

void delay(uint32_t ms){
	
	for(uint32_t i = 0; i < 3600; i++){
			for(uint32_t j = 0; j < ms; j++) __NOP();
	}
					
}


void display_select_pos(uint8_t pos){
	
	/* obsluga pozycji dziesietnych wyswietlacza (wspolne anody) */
	
	switch(pos){
		
		case 0:
			GPIO_ResetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
			break;
		
		case 1:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_ResetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
			break;		
		
		case 2:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_ResetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
			break;	
		
		case 3:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_ResetBits(DISP_COM4_port, DISP_COM4_pin);
			break;	
	
		default:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
		
	}
}

void display_select_digit(uint8_t dig, uint8_t dp){
	
	/* obsluga segmentow wyswietlacza (katody) */
	
	switch(dig){
		
		case 0:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;
		
		case 1:
			GPIO_ResetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 2:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_ResetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;	

		case 3:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;	

		case 4:
			GPIO_ResetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 5:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_ResetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;		
	
		case 6:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_ResetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 7:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 8:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;
		
		case 9:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;		
		
		default:
			GPIO_ResetBits(DISP_A_port, DISP_A_pin);
			GPIO_ResetBits(DISP_B_port, DISP_B_pin);
			GPIO_ResetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);

	}	
	
	/* obsluga punktu dziesietnego */
	if(dp){
		GPIO_SetBits(DISP_DP_port, DISP_DP_pin);
	}else{
		GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
	}
		
}


void UART_config(uint32_t apbclk_hz, uint32_t baudrate_bps){
	
	/* zmienna do obliczenia rejestrow timingu */
	uint32_t div;
	
	/* wlaczenie taktowania interfejsu UART1 */
  RCC->APB1PRE |= RCC_APB1PRE_SRCEN;
  RCC->APB1ENR |= (RCC_APB1ENR_BMX1EN | RCC_APB1ENR_UART1EN);
  
  /* reset interfejsu UART1 */
  RCC->APB1RSTR |= RCC_APB1RSTR_UART1RST;
  RCC->APB1RSTR &= ~RCC_APB1RSTR_UART1RST;
  
  /* wyzerowanie rejestru funkcji modemowych */
  UART1->MCR = 0x00;
	/* obliczenie wartosci dzielnika */
  div = apbclk_hz / baudrate_bps;
  /* ulamkowa czesc dzielnika - tylko 4 najmlodsze bity */
  UART1->DLF = div & 0x0F;
  /* zezwolenie na zapis calkowitej czesci dzielnika */
  UART1->LCR = UART_LCR_DLAB;
  /* zapis calkowitej czesci dzielnika */
	/* mlodsze polslowo */
	UART1->DLL = (uint8_t)(div >> 4);
	/* starsze polslowo */
	UART1->DLH = (uint8_t)(div >> 12);
  /* konfiguracja trybu transmisji: 8N1 */
	UART1->LCR = UART_LCR_WLS_8BIT | UART_LCR_SBS_1BIT | UART_LCR_PARITY_NONE;
  /* wlaczenie FIFO */
	UART1->FCR = UART_FCR_FIFOE;
	
}


void UART_print(char *str)
{
  /* petla po wszystkich znakach */
	/* az do wystapienia znaku konca stringa = 0x00 */
	while(*str)
  {
    /* oczekiwanie na zwolnienie bufora nadawczego */
		while(!(UART1->LSR & UART_LSR_THRE)){};
		/* zapis kolejnego bajtu do bufora */
    UART1->THR = *str;
		/* inkrementacja wskaznika */
		str++;
  }
	/* oczekiwanie na wyslanie ostatniego bajtu */
  while(!(UART1->LSR & UART_LSR_TEMT));
}

char UART_getchar(void){
	/* oczekiwanie na odbior bajtu */	
	while(!(UART1->LSR & UART_LSR_DR));
	/* zwrocenie odebranego bajtu */	
	return (UART1->RBR);
}



void RTC_Config(void)
{
  /* reset domeny BACKUP */
  BKP_DeInit();

  /* wlaczenie oscylatora LSE (32,768 kHz) */
  BKP_LSEConfig(BKP_LSE_ON);
  /* oczekiwanie na uruchomienie LSE */
  while (BKP_GetLSEReadyFlagStatus() == RESET){}
  /* wybor LSE jako zrodla taktowania dla RTC */
  BKP_RTCCLKConfig(BKP_RTCCLKSource_LSE);
  /* wlaczenie RTC */
  BKP_RTCCLKCmd(ENABLE);
  /* oczekiwanie na synchronizacje z szyna systemowa */
  RTC_WaitForSynchro();
  /* oczekiwanie na zakonczenie ostatniej operacji */
  RTC_WaitForLastTask();
  /* wlaczenie przerwania od sekund */
  RTC_ITConfig(RTC_IT_SEC, ENABLE);
  /* oczekiwanie na zakonczenie ostatniej operacji */
  RTC_WaitForLastTask();
		/* ustawienie preskalera: 32,768 kHz/(32767+1) = 1 Hz */
  RTC_SetPrescaler(32767);
  /* oczekiwanie na zakonczenie ostatniej operacji */
  RTC_WaitForLastTask();
		/* ustawienie domyslnej godziny: 12:00:00 */
  RTC_SetCounter(43200);
}

void NVIC_Config(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;

  /* konfiguracja przerwania od RTC*/
  NVIC_InitStructure.NVIC_IRQChannel = RTC_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}
